/*
 * Copyright (c) 2003-2024
 * Distributed Systems Software.  All rights reserved.
 * See the file LICENSE for redistribution information.
 *
 * $Id: crypto_engine.h 3295 2024-03-21 21:18:07Z brachman $
 */

#ifndef _CRYPTO_ENGINE_H_
#define _CRYPTO_ENGINE_H_

#include <openssl/engine.h>

#ifdef __cplusplus
extern "C" {
#endif

extern int crypto_engine_init(Digest_tab *dt);
extern void crypto_engine_end(void);

extern EVP_MD *crypto_engine_make_ctx(Digest_tab *dt);
extern int crypto_engine_tests(void);

#ifdef __cplusplus
}
#endif

#endif
