[4mDACS_PRENV[24m(8)              DACS Web Services Manual              [4mDACS_PRENV[24m(8)

[1mNAME dacs_prenv - CGI program that displays its environment[0m

[1mSYNOPSIS[0m

       [1mdacs_prenv [22m[[1m-html[22m]

[1mDESCRIPTION[0m

       This program is part of the [1mDACS [22msuite. It is a stand-alone program
       that neither accepts the usual [1mDACS [22mcommand line options ([4mdacsoptions[24m)
       nor accesses any [1mDACS [22mconfiguration files.

       This CGI utility simply prints its command line arguments, all
       environment variables, information about the system on which it is
       running, and CGI parameters and their values. It can be a useful tool
       when debugging web services.

           [1mTip[0m

           This program can be a useful tool for debugging web services.
           Replace a call to your web service with an identical call to
           [1mdacs_prenv [22mto see what arguments your web service is being passed
           and (to some extent) other context.

[1mOPTIONS[0m

       [1mdacs_prenv [22mrecognizes these command line flags:

       [1m-html[0m
           Selects HTML output (text/html) instead of the default Content-Type
           of text/plain, by default, using the style sheet [34m[1mdacs_prenv.css[0m[1m[22m[1].

   [1mWeb Service Arguments[0m

       When used as a web service, the following parameters are recognized:

       [4mFORMAT[0m
           At present, the only recognized value for this argument is HTML.

       [4mjust_dump_stdin[0m
           If the value of [1mQUERY_STRING [22mis exactly jump_dump_stdin, then the
           program will simply copy its standard input to the standard output
           as text/plain.

[1mFILES[0m

       [34m[1mdacs_prenv.css[0m[1m[22m[1]

[1mDIAGNOSTICS[0m

       The program exits 0 if everything was fine, 1 if an error occurred.

[1mBUGS[0m

       It should be possible to request XML output.

[1mSEE ALSO[0m

       [34m[1mcgiparse(8)[0m[1m[22m[2], [34m[1menv(1)[0m[1m[22m[3], [34m[1mprintenv(1)[0m[1m[22m[4], [34m[1menviron(7)[0m[1m[22m[5]

[1mAUTHOR[0m

       Distributed Systems Software ([34m[1mwww.dss.ca[0m[1m[22m[6])




[1mCOPYING[0m

       Copyright © 2003-2025 Distributed Systems Software. See the [34m[1mLICENSE[0m[1m[22m[7]
       file that accompanies the distribution for licensing information.




[1mNOTES[0m

        1.
           dacs_prenv.css
           http://dacs.dss.ca/man//css/dacs_prenv.css

        2. cgiparse(8)
           http://dacs.dss.ca/man/cgiparse.8.html

        3. env(1)
           https://www.freebsd.org/cgi/man.cgi?query=env&apropos=0&sektion=1&manpath=FreeBSD+14.2‐RELEASE&format=html

        4. printenv(1)
           https://www.freebsd.org/cgi/man.cgi?query=printenv&apropos=0&sektion=1&manpath=FreeBSD+14.2‐RELEASE&format=html

        5. environ(7)
           https://www.freebsd.org/cgi/man.cgi?query=environ&apropos=0&sektion=7&manpath=FreeBSD+14.2‐RELEASE&format=html

        6. www.dss.ca
           https://www.dss.ca

        7. LICENSE
           http://dacs.dss.ca/man/../misc/LICENSE

DACS 1.5.0                        04/09/2025                     [4mDACS_PRENV[24m(8)
